#ifndef __RdmaFuture__
#define __RdmaFuture__
#include <stdint.h>
#include <memory>
#include <atomic>
#include <iostream>
#include <mutex>
#include <condition_variable>

class RdmaFuture
{
    static int DONE;
    static int PENDING;
    uint8_t _status;

    /* Used to identify future for a particular request.
     * It is same as request id for packet generated
     */
    uint64_t _requestId;
    char *_data;

    std::mutex stateMutex;
    std::condition_variable stateCv;
    uint8_t state{0};

public:
    RdmaFuture(uint64_t requestId);

    char *get();
    char *wait_for(int timeout);
    void put(char *data);
};
#endif