#include "RdmaFuture.hpp"

int RdmaFuture::DONE = 2;
int RdmaFuture::PENDING = 1;
RdmaFuture::RdmaFuture(uint64_t id)
    : _requestId(id), _data(nullptr)
{
    state = PENDING;
}

char *RdmaFuture::get()
{
    // std::cout << (unsigned)state << std::endl;
    std::unique_lock<std::mutex> lock(stateMutex);
    while (state != DONE)
    {
        //std::cout << "getting data\n";
        stateCv.wait(lock,[&]{return state == DONE;});
    }
    return _data;
    // [this](){return state!=DONE;});
    // lock.unlock();
    // stateCv.wait(stateMutex, [](state != DONE;));
    //  std::cout<<"get"<<std::endl;
}
char *RdmaFuture::wait_for(int timeout)
{
    std::unique_lock<std::mutex> lock(stateMutex);
    if (state == DONE)
        return _data;
    // lock.unlock();
    //  add wait logic
    return nullptr;
}
void RdmaFuture::put(char *data)
{
    std::unique_lock<std::mutex> lock(stateMutex);
    //std::cout << "putting data\n";
    _data = data;
    state = DONE;
    // lock.unlock();
    stateCv.notify_one();
    // std::cout << "got data current state" <<data<< (unsigned)state;
    //  std::unique_lock<std::mutex> lock(stateMutex);
    // std::cout << "updated" << (unsigned)state;
}